import { defineComponent, ref, computed, watch, openBlock, createElementBlock, normalizeClass, unref, normalizeStyle, createCommentVNode, renderSlot, watchEffect, withDirectives, createElementVNode, vShow, Fragment, renderList, createVNode, toDisplayString } from "vue";
const domain = "https://wlmvp-cos.weiling.cn";
const loadingPic = domain + "/frontend/weilingMobileUI/loading.png";
const loadingFailPic = domain + "/frontend/weilingMobileUI/loadingFail.png";
const addIcon = domain + "/frontend/weilingMobileUI/addIcon.png";
const loadImage = (url) => {
  return new Promise((resolve, reject) => {
    const newImg = new Image();
    newImg.src = url;
    newImg.onerror = () => {
      reject("failure");
    };
    newImg.onload = (e) => {
      resolve(e.target);
    };
  });
};
const isTencentCosPic = (url) => {
  return url.includes("wlmvp-cos.weiling.cn");
};
const isBase64 = (str) => {
  return str.indexOf("data:") != -1 && str.indexOf("base64") != -1;
};
const _hoisted_1$1 = ["src", "alt"];
const _hoisted_2$1 = ["src"];
const _hoisted_3$1 = ["src"];
var ECosType = /* @__PURE__ */ ((ECosType2) => {
  ECosType2["normal"] = "imageView2/1/q/85";
  ECosType2["thumbnail"] = "imageView2/1/w/100/h/100/q/85";
  return ECosType2;
})(ECosType || {});
const __default__$1 = {
  name: "WlPic"
};
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  ...__default__$1,
  props: {
    src: { default: "" },
    needCos: { type: Boolean, default: true },
    cosType: { default: "normal" },
    radius: { type: Boolean, default: false },
    round: { type: Boolean, default: false },
    needLoading: { type: Boolean, default: true },
    needMiddleCenter: { type: Boolean, default: true },
    needHeightAuto: { type: Boolean, default: false },
    fit: { default: "fill" }
  },
  setup(__props, { expose }) {
    const props = __props;
    const isLoading = ref(true);
    const isError = ref(false);
    const imgSrc = ref("");
    const imgWrapRef = ref("");
    const imgStyleComputed = computed(() => {
      return {
        "border-radius": props.round ? "50%" : "",
        "object-fit": props.fit
      };
    });
    const imgWrapClassComputed = computed(() => {
      return [
        "wl-img",
        "wh-full",
        "relative",
        "flex-col",
        props.needMiddleCenter ? "flex-middle-center" : ""
      ];
    });
    const onLoadImage = (url) => {
      return new Promise((resolve, reject) => {
        loadImage(url).then((elem) => {
          resolve(elem);
        }).catch((reason) => {
          reject(reason);
        }).finally(() => {
          isLoading.value = false;
        });
      });
    };
    const setImgSrc = (url) => {
      const needCos = isTencentCosPic(url) && props.needCos;
      const file_type = url.split(".").pop();
      let isSvg = file_type === "svg";
      let isBase64Bool = isBase64(url);
      if (isSvg || !needCos || isBase64Bool) {
        imgSrc.value = url;
        onLoadImage(imgSrc.value).catch(() => {
          isError.value = true;
        });
      } else {
        imgSrc.value = `${url}?${ECosType[props.cosType]}`;
        onLoadImage(imgSrc.value).catch(() => {
          imgSrc.value = url;
        });
      }
    };
    watch(
      () => props.src,
      (val) => {
        if (val) {
          isLoading.value = true;
          setImgSrc(props.src);
        }
      },
      { immediate: true }
    );
    expose({
      imgWrapRef
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(unref(imgWrapClassComputed)),
        ref_key: "imgWrapRef",
        ref: imgWrapRef
      }, [
        !isLoading.value && !isError.value ? (openBlock(), createElementBlock("img", {
          key: 0,
          src: imgSrc.value,
          style: normalizeStyle(unref(imgStyleComputed)),
          class: normalizeClass(`w-full block ${__props.needHeightAuto ? "h-auto" : "h-full"}`),
          alt: imgSrc.value
        }, null, 14, _hoisted_1$1)) : createCommentVNode("", true),
        isLoading.value && __props.needLoading ? (openBlock(), createElementBlock("img", {
          key: 1,
          src: unref(loadingPic),
          alt: "loading",
          class: "w-1/5 uno-min-w-20 uno-min-h-20 uno-max-w-60 uno-max-h-60 absolute-middle-center animate-spin"
        }, null, 8, _hoisted_2$1)) : createCommentVNode("", true),
        isError.value ? (openBlock(), createElementBlock("img", {
          key: 2,
          src: unref(loadingFailPic),
          alt: "failure",
          class: "w-1/5 uno-min-w-20 uno-min-h-20 uno-max-w-60 uno-max-h-60 absolute-middle-center"
        }, null, 8, _hoisted_3$1)) : createCommentVNode("", true),
        renderSlot(_ctx.$slots, "picFooter")
      ], 2);
    };
  }
});
var index_vue_vue_type_style_index_0_lang = "";
const _hoisted_1 = {
  class: "fixed-menu",
  "data-weiling-mobile-ui-wl-fixed-menu": ""
};
const _hoisted_2 = { class: "menu-btn" };
const _hoisted_3 = ["onClick"];
const _hoisted_4 = { class: "icon" };
const __default__ = {
  name: "WlFixedMenu"
};
const _sfc_main = /* @__PURE__ */ defineComponent({
  ...__default__,
  props: {
    data: { default: null },
    modelValue: { type: Boolean, default: false }
  },
  emits: ["onClick", "onChange", "update:modelValue"],
  setup(__props, { emit }) {
    const props = __props;
    const modalVisible = ref(false);
    const fixedMenuButtonClass = computed(() => {
      return {
        animated: true,
        "fixed-menu-button": true,
        rotated: modalVisible.value
      };
    });
    const onMenuClick = (item) => {
      emit("onChange", item);
      modalVisible.value = false;
    };
    const onToggle = () => {
      var _a;
      emit("onClick");
      if (((_a = props.data) != null ? _a : []).length > 0)
        modalVisible.value = !modalVisible.value;
    };
    watchEffect(() => {
      modalVisible.value = props.modelValue;
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1, [
        withDirectives(createElementVNode("div", {
          class: "blur-modal animate__animated animate__fadeIn",
          onClick: _cache[0] || (_cache[0] = ($event) => modalVisible.value = false)
        }, null, 512), [
          [vShow, modalVisible.value]
        ]),
        withDirectives(createElementVNode("ul", _hoisted_2, [
          (openBlock(true), createElementBlock(Fragment, null, renderList(__props.data, (item) => {
            return withDirectives((openBlock(), createElementBlock("li", {
              class: "add-follow animate__animated animate__bounceInRight",
              key: item.key,
              onClick: ($event) => onMenuClick(item)
            }, [
              !item.slot ? (openBlock(), createElementBlock(Fragment, { key: 0 }, [
                createElementVNode("div", _hoisted_4, [
                  createVNode(_sfc_main$1, {
                    src: item.icon
                  }, null, 8, ["src"])
                ]),
                createElementVNode("p", null, toDisplayString(item.text), 1)
              ], 64)) : renderSlot(_ctx.$slots, item.slot, { key: 1 })
            ], 8, _hoisted_3)), [
              [vShow, item.isShow]
            ]);
          }), 128))
        ], 512), [
          [vShow, modalVisible.value]
        ]),
        createElementVNode("div", {
          class: normalizeClass(unref(fixedMenuButtonClass)),
          onClick: onToggle
        }, [
          createElementVNode("div", {
            class: normalizeClass(`icon ${modalVisible.value ? "rotate" : ""}`)
          }, [
            createVNode(_sfc_main$1, { src: unref(addIcon) }, null, 8, ["src"])
          ], 2)
        ], 2)
      ]);
    };
  }
});
var __uno = "";
_sfc_main.install = (app) => {
  app.component(_sfc_main.name, _sfc_main);
};
export { _sfc_main as default };
